{-# LANGUAGE PatternSynonyms, ScopedTypeVariables, ViewPatterns #-}


{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Poppler.Constants
    ( 
    pattern MINOR_VERSION                   ,
    pattern MICRO_VERSION                   ,
    pattern MAJOR_VERSION                   ,
    pattern HAS_CAIRO                       ,
    pattern ANNOT_TEXT_ICON_PARAGRAPH       ,
    pattern ANNOT_TEXT_ICON_NOTE            ,
    pattern ANNOT_TEXT_ICON_NEW_PARAGRAPH   ,
    pattern ANNOT_TEXT_ICON_KEY             ,
    pattern ANNOT_TEXT_ICON_INSERT          ,
    pattern ANNOT_TEXT_ICON_HELP            ,
    pattern ANNOT_TEXT_ICON_CROSS           ,
    pattern ANNOT_TEXT_ICON_COMMENT         ,
    pattern ANNOT_TEXT_ICON_CIRCLE          ,

    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL


{- |
The major version number of the poppler header files (e.g. in poppler version
0.1.2 this is 1.)

/Since: 0.12/
-}
pattern MINOR_VERSION = 73 :: Int32

{- |
The micro version number of the poppler header files (e.g. in poppler version
0.1.2 this is 2.)

/Since: 0.12/
-}
pattern MICRO_VERSION = 0 :: Int32

{- |
The major version number of the poppler header files (e.g. in poppler version
0.1.2 this is 0.)

/Since: 0.12/
-}
pattern MAJOR_VERSION = 0 :: Int32

{- |
Defined if poppler was compiled with cairo support.
-}
pattern HAS_CAIRO = 1 :: Int32

{- |
/No description available in the introspection data./
-}
pattern ANNOT_TEXT_ICON_PARAGRAPH = "Paragraph" :: T.Text

{- |
/No description available in the introspection data./
-}
pattern ANNOT_TEXT_ICON_NOTE = "Note" :: T.Text

{- |
/No description available in the introspection data./
-}
pattern ANNOT_TEXT_ICON_NEW_PARAGRAPH = "NewParagraph" :: T.Text

{- |
/No description available in the introspection data./
-}
pattern ANNOT_TEXT_ICON_KEY = "Key" :: T.Text

{- |
/No description available in the introspection data./
-}
pattern ANNOT_TEXT_ICON_INSERT = "Insert" :: T.Text

{- |
/No description available in the introspection data./
-}
pattern ANNOT_TEXT_ICON_HELP = "Help" :: T.Text

{- |
/No description available in the introspection data./
-}
pattern ANNOT_TEXT_ICON_CROSS = "Cross" :: T.Text

{- |
/No description available in the introspection data./
-}
pattern ANNOT_TEXT_ICON_COMMENT = "Comment" :: T.Text

{- |
/No description available in the introspection data./
-}
pattern ANNOT_TEXT_ICON_CIRCLE = "Circle" :: T.Text


