

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Poppler.Structs.ActionUri
    ( 

-- * Exported types
    ActionUri(..)                           ,
    newZeroActionUri                        ,
    noActionUri                             ,


 -- * Properties
-- ** title #attr:title#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    actionUri_title                         ,
#endif
    clearActionUriTitle                     ,
    getActionUriTitle                       ,
    setActionUriTitle                       ,


-- ** type #attr:type#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    actionUri_type                          ,
#endif
    getActionUriType                        ,
    setActionUriType                        ,


-- ** uri #attr:uri#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    actionUri_uri                           ,
#endif
    clearActionUriUri                       ,
    getActionUriUri                         ,
    setActionUriUri                         ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import {-# SOURCE #-} qualified GI.Poppler.Enums as Poppler.Enums

-- | Memory-managed wrapper type.
newtype ActionUri = ActionUri (ManagedPtr ActionUri)
instance WrappedPtr ActionUri where
    wrappedPtrCalloc = callocBytes 24
    wrappedPtrCopy = \p -> withManagedPtr p (copyBytes 24 >=> wrapPtr ActionUri)
    wrappedPtrFree = Just ptr_to_g_free

-- | Construct a `ActionUri` struct initialized to zero.
newZeroActionUri :: MonadIO m => m ActionUri
newZeroActionUri = liftIO $ wrappedPtrCalloc >>= wrapPtr ActionUri

instance tag ~ 'AttrSet => Constructible ActionUri tag where
    new _ attrs = do
        o <- newZeroActionUri
        GI.Attributes.set o attrs
        return o


-- | A convenience alias for `Nothing` :: `Maybe` `ActionUri`.
noActionUri :: Maybe ActionUri
noActionUri = Nothing

{- |
Get the value of the “@type@” field.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' actionUri #type
@
-}
getActionUriType :: MonadIO m => ActionUri -> m Poppler.Enums.ActionType
getActionUriType s = liftIO $ withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO CUInt
    let val' = (toEnum . fromIntegral) val
    return val'

{- |
Set the value of the “@type@” field.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' actionUri [ #type 'Data.GI.Base.Attributes.:=' value ]
@
-}
setActionUriType :: MonadIO m => ActionUri -> Poppler.Enums.ActionType -> m ()
setActionUriType s val = liftIO $ withManagedPtr s $ \ptr -> do
    let val' = (fromIntegral . fromEnum) val
    poke (ptr `plusPtr` 0) (val' :: CUInt)

#if ENABLE_OVERLOADING
data ActionUriTypeFieldInfo
instance AttrInfo ActionUriTypeFieldInfo where
    type AttrAllowedOps ActionUriTypeFieldInfo = '[ 'AttrSet, 'AttrGet]
    type AttrSetTypeConstraint ActionUriTypeFieldInfo = (~) Poppler.Enums.ActionType
    type AttrBaseTypeConstraint ActionUriTypeFieldInfo = (~) ActionUri
    type AttrGetType ActionUriTypeFieldInfo = Poppler.Enums.ActionType
    type AttrLabel ActionUriTypeFieldInfo = "type"
    type AttrOrigin ActionUriTypeFieldInfo = ActionUri
    attrGet _ = getActionUriType
    attrSet _ = setActionUriType
    attrConstruct = undefined
    attrClear _ = undefined

actionUri_type :: AttrLabelProxy "type"
actionUri_type = AttrLabelProxy

#endif


{- |
Get the value of the “@title@” field.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' actionUri #title
@
-}
getActionUriTitle :: MonadIO m => ActionUri -> m (Maybe T.Text)
getActionUriTitle s = liftIO $ withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 8) :: IO CString
    result <- SP.convertIfNonNull val $ \val' -> do
        val'' <- cstringToText val'
        return val''
    return result

{- |
Set the value of the “@title@” field.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' actionUri [ #title 'Data.GI.Base.Attributes.:=' value ]
@
-}
setActionUriTitle :: MonadIO m => ActionUri -> CString -> m ()
setActionUriTitle s val = liftIO $ withManagedPtr s $ \ptr -> do
    poke (ptr `plusPtr` 8) (val :: CString)

{- |
Set the value of the “@title@” field to `Nothing`.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.clear' #title
@
-}
clearActionUriTitle :: MonadIO m => ActionUri -> m ()
clearActionUriTitle s = liftIO $ withManagedPtr s $ \ptr -> do
    poke (ptr `plusPtr` 8) (FP.nullPtr :: CString)

#if ENABLE_OVERLOADING
data ActionUriTitleFieldInfo
instance AttrInfo ActionUriTitleFieldInfo where
    type AttrAllowedOps ActionUriTitleFieldInfo = '[ 'AttrSet, 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint ActionUriTitleFieldInfo = (~) CString
    type AttrBaseTypeConstraint ActionUriTitleFieldInfo = (~) ActionUri
    type AttrGetType ActionUriTitleFieldInfo = Maybe T.Text
    type AttrLabel ActionUriTitleFieldInfo = "title"
    type AttrOrigin ActionUriTitleFieldInfo = ActionUri
    attrGet _ = getActionUriTitle
    attrSet _ = setActionUriTitle
    attrConstruct = undefined
    attrClear _ = clearActionUriTitle

actionUri_title :: AttrLabelProxy "title"
actionUri_title = AttrLabelProxy

#endif


{- |
Get the value of the “@uri@” field.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' actionUri #uri
@
-}
getActionUriUri :: MonadIO m => ActionUri -> m (Maybe T.Text)
getActionUriUri s = liftIO $ withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 16) :: IO CString
    result <- SP.convertIfNonNull val $ \val' -> do
        val'' <- cstringToText val'
        return val''
    return result

{- |
Set the value of the “@uri@” field.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' actionUri [ #uri 'Data.GI.Base.Attributes.:=' value ]
@
-}
setActionUriUri :: MonadIO m => ActionUri -> CString -> m ()
setActionUriUri s val = liftIO $ withManagedPtr s $ \ptr -> do
    poke (ptr `plusPtr` 16) (val :: CString)

{- |
Set the value of the “@uri@” field to `Nothing`.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.clear' #uri
@
-}
clearActionUriUri :: MonadIO m => ActionUri -> m ()
clearActionUriUri s = liftIO $ withManagedPtr s $ \ptr -> do
    poke (ptr `plusPtr` 16) (FP.nullPtr :: CString)

#if ENABLE_OVERLOADING
data ActionUriUriFieldInfo
instance AttrInfo ActionUriUriFieldInfo where
    type AttrAllowedOps ActionUriUriFieldInfo = '[ 'AttrSet, 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint ActionUriUriFieldInfo = (~) CString
    type AttrBaseTypeConstraint ActionUriUriFieldInfo = (~) ActionUri
    type AttrGetType ActionUriUriFieldInfo = Maybe T.Text
    type AttrLabel ActionUriUriFieldInfo = "uri"
    type AttrOrigin ActionUriUriFieldInfo = ActionUri
    attrGet _ = getActionUriUri
    attrSet _ = setActionUriUri
    attrConstruct = undefined
    attrClear _ = clearActionUriUri

actionUri_uri :: AttrLabelProxy "uri"
actionUri_uri = AttrLabelProxy

#endif



#if ENABLE_OVERLOADING
instance O.HasAttributeList ActionUri
type instance O.AttributeList ActionUri = ActionUriAttributeList
type ActionUriAttributeList = ('[ '("type", ActionUriTypeFieldInfo), '("title", ActionUriTitleFieldInfo), '("uri", ActionUriUriFieldInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
type family ResolveActionUriMethod (t :: Symbol) (o :: *) :: * where
    ResolveActionUriMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveActionUriMethod t ActionUri, O.MethodInfo info ActionUri p) => OL.IsLabel t (ActionUri -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif


